close all;
clear

n = 200;
% costruire il segnale in input
[H,y,exactsol] = signalrec(n);

condnumb=cond(H)
size(H)
% creare il vettore errore
LIVRUM=0.01;
% Livello di rumore: modificare LIVRUM per avere piu' o meno rumore
err=LIVRUM*randn(n,1);

%output misurato
ymis = y + err;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[U,S,V]=svd(H,0);
figure
plot(diag(S));
title('valori singolari di A');
figure
hold on
plot(exactsol);
plot(ymis,'r');
plot(y,'k');
hold off
figure
hold on
plot(exactsol);
plot(y,'k');
hold off

% stima approssimazione ai minimi quadrati
figure
xls = H\ymis;
plot(xls,'r');

% stima approssimazione mediante TSVD
tol=input('TSVD:    Inserire Tolleranza di soglia valori singolari, tol=0 per terminare');
while tol>0
 x_reg = risolvi_SVD(H,ymis,tol)
 figure
 hold on
 plot(x_reg,'-r')
 plot(exactsol,'-k');
 legend('Soluzione con SVD','Soluzione esatta')
 hold off
 err=norm(x_reg-exactsol)
 tol=input('TSVD:    Inserire Tolleranza di soglia valori singolari, tol=0 per terminare');
end

%stima approssimazione mediante Tikhonov
gamma=input('Tikhonov:  Parametro di regolarizzazione, Inserire gamma>0, gamma=-1 per terminare');
while gamma>0
    G=H'*H+gamma*eye(size(H));
    b=H'*ymis;
    R=chol(G);
    L=R';
    z=L\b;
    xT=R\z;
    figure
    hold on
    plot(xT,'-g')
    plot(exactsol,'-k');
    err=norm(xT-exactsol)     
    legend('Soluzione con Tikhonov','Soluzione esatta')
    hold off
    gamma=input('Tikhonov:   Parametro di regolarizzazione, Inserire gamma, gamma=-1 per terminare');
end

    